#ifndef _NETDD_NET_H_
#define _NETDD_NET_H_

#include <sys/socket.h>

struct net_host_id {
	int len;
	int port;
	unsigned char addr[16];
};

int net_info(struct net_host_id *id, char *hostname);
int net_are_same_ips(struct net_host_id *id1, struct net_host_id *id2);
int net_get_id(struct net_host_id *id, struct sockaddr *sockname);
int net_print_id(char *str, struct net_host_id *id, int maxlen);

int net_bind(int *port_result, char *hostname, char *port, char *protocol,
	     int reuse);
int net_bind_tcp4_hack(int *port_res, int reuse);
int net_open(char *hostname, char *port, char *protocol, char *local_host);
int net_reuseaddr(int fd);

#endif
