#include <time.h>
#include <assert.h>
#include <sys/select.h>

#include "support.h"

/* A stupid function */
int xsleep(unsigned int nsecs)
{
	time_t s, os, d;

	s = time(NULL);
	if (s == (time_t) -1)
		return -1;

	d = s + nsecs;
	if (d < s)
		return -1; /* overflow */

	while (1) {
		os = s;

		s = time(NULL);
		if (s == (time_t) -1)
			return -1;

		if (s < os) {
			/* time went backwards, set a new target */
			d = (d - os) + s;
			continue;
		}

		if (s >= d)
			break;

		select(0, NULL, NULL, NULL,
		       & (struct timeval) {.tv_sec = (d - s)});
	}

	return 0;
}
